--[[
الإملاء الصوتي العربي الفرنسي.
هذه الإضافة ستمكنكم من استخدام الإملاء الصوتي باللغة العربية و الفرنسية.
المطور: عبد الكريم بن سعيد.
عضو في مجموعة جيشيو للعرب.
]]

require "import";
import "android.speech.RecognizerIntent";
import "com.androlua.LuaDialog";
import "android.speech.RecognitionListener";
import "android.speech.SpeechRecognizer";
import "android.content.Intent";
import "java.io.File";
import "java.io.FileInputStream";
import "java.io.FileWriter";
import "com.androlua.LuaUtil";
import "java.lang.String";
import "java.nio.charset.StandardCharsets";

-- هذه هي قائمة اللغات القابلة للإملاء.
local langs = {
    "العربية",
    "الفرنسية"
};
local values = {
    "ar_SA",
    "fr_FR"
}

local selectedLangFilePath = service.getLuaExtDir() .. File.separator .. "selected_lang";
local file = File(selectedLangFilePath);
local edit = service.getEditText();


-- هذه الوظيفة ستقوم بعملية الإملائ الصوتي.
function voiceRecognition(activity, lang)
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, lang);
    local recognitionListener = RecognitionListener {
        onResults = function(params)
            -- هنا، نقوم باستخلاص النص الذي قمنا بإملائه.
            local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            -- نقوم بتخصيص كائن لحقل الكتابة.
            local edit = service.getEditText();
            -- نقوم بتخصيص كائن للنص الذي مليناه.
            local text = tostring(results[0]);
            -- نقرأ النص.
            service.speak(text);
            task(200, function()
                -- نكتب النص في حقل الكتابة.
                service.insertText(edit, text);
            end)
        end,
    }
    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
end

if not edit or not file.exists() then -- لا يوجد حقل للكتابة أو هذا أول استخدام للإضافة.
    dlg=LuaDialog()
    dlg.setTitle("اختيار اللغة للإملائ الصوتي");
    dlg.setMessage([[اختر اللغة التي تريد استخدامَها للإِملائ الصوتي.
    هذه النافدة تُفْتَحُ فقط عند أول استخدام للإضافة في حقل كتابة، و تُفَْحُ دائما حينما يكون التركيز في نافدة لا تحتوي على حقل كتابة]]);
    dlg.setItems(langs);
    dlg.show();
    dlg.onItemClick=function(l,v,p,i)
        dlg.dismiss();
        task(50 , function()
            writer = FileWriter(selectedLangFilePath);
            writer.write(values[i]);
            writer.close();
            if edit then
                voiceRecognition(this, values[i]);
                return
            end
            service.speak("لقد تم تحديد " .. langs[i] .. "توجهوا إلى حقل تحرير لإستخدامها مع الإملاء الصوتي");
        end);
    end
    return
end

if file.exists() then
    local inputStream = FileInputStream(file);
    local selectedLang = LuaUtil.readAll(inputStream);
    selectedLang  = String(selectedLang, StandardCharsets.UTF_8);
    selectedLang  = tostring(selectedLang);
    voiceRecognition(this, selectedLang);
end
return true;